use std::{net::TcpStream, sync::atomic::AtomicBool};

use kernel::tcp::{self, StatusServer};

pub fn setup() -> (StatusServer, TcpClient) {
    let server = StatusServer::new(7878, String::from("127.0.0.1").as_str());

    let client = TcpClient {
        port: 7878,
        ip: String::from("127.0.0.1"),
    };

    (server, client)
}

pub struct TcpClient {
    pub port: i32,
    pub ip: String,
}

impl TcpClient {
    pub fn new(port: i32, ip: String) -> TcpClient {
        TcpClient { port, ip }
    }
    pub fn test_connection(&self) {
        let stream = TcpStream::connect(format!("{}:{}", self.port, self.ip)).unwrap();
    }
}
