#!/usr/bin/env python3
from queue import Queue
import socketserver
import socket
from statusd_server.models import Cpu
from statusd_server.proto.messages import *
from statusd_server.converters import Converter


class Server:
    def __init__(self, queue: Queue, converter: Converter):
        self.queue = queue
        self.converter = converter

    def run(self):
        print("run tcp server")
        with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as s:
            s.bind(("127.0.0.1", 6654))
            s.listen()
            print("Connected by {addr}")
            while True:
                conn, addr = s.accept()
                with conn:
                    data = conn.recv(512)
                    print("received data")
                    request = Request().parse(data)

                    if request.metric == RequestMetric.CPU:
                        body: Cpu = self.converter.ToCpu(request.body)
                        self.queue.put(body)
